<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Offer_RequestType StructType
 * Meta information extracted from the WSDL
 * - documentation: A request to initiate offer
 * @subpackage Structs
 */
class Offer_RequestType extends AbstractStructBase
{
    /**
     * The Dynamic_Business_Process_Parameters
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Dynamic_Business_Process_ParametersType
     */
    public $Dynamic_Business_Process_Parameters;
    /**
     * The Offer_Data
     * @var \StructType\Offer_DataType
     */
    public $Offer_Data;
    /**
     * The version
     * Meta information extracted from the WSDL
     * - ref: wd:version
     * @var string
     */
    public $version;
    /**
     * Constructor method for Offer_RequestType
     * @uses Offer_RequestType::setDynamic_Business_Process_Parameters()
     * @uses Offer_RequestType::setOffer_Data()
     * @uses Offer_RequestType::setVersion()
     * @param \StructType\Dynamic_Business_Process_ParametersType $dynamic_Business_Process_Parameters
     * @param \StructType\Offer_DataType $offer_Data
     * @param string $version
     */
    public function __construct(\StructType\Dynamic_Business_Process_ParametersType $dynamic_Business_Process_Parameters = null, \StructType\Offer_DataType $offer_Data = null, $version = null)
    {
        $this
            ->setDynamic_Business_Process_Parameters($dynamic_Business_Process_Parameters)
            ->setOffer_Data($offer_Data)
            ->setVersion($version);
    }
    /**
     * Get Dynamic_Business_Process_Parameters value
     * @return \StructType\Dynamic_Business_Process_ParametersType|null
     */
    public function getDynamic_Business_Process_Parameters()
    {
        return $this->Dynamic_Business_Process_Parameters;
    }
    /**
     * Set Dynamic_Business_Process_Parameters value
     * @param \StructType\Dynamic_Business_Process_ParametersType $dynamic_Business_Process_Parameters
     * @return \StructType\Offer_RequestType
     */
    public function setDynamic_Business_Process_Parameters(\StructType\Dynamic_Business_Process_ParametersType $dynamic_Business_Process_Parameters = null)
    {
        $this->Dynamic_Business_Process_Parameters = $dynamic_Business_Process_Parameters;
        return $this;
    }
    /**
     * Get Offer_Data value
     * @return \StructType\Offer_DataType|null
     */
    public function getOffer_Data()
    {
        return $this->Offer_Data;
    }
    /**
     * Set Offer_Data value
     * @param \StructType\Offer_DataType $offer_Data
     * @return \StructType\Offer_RequestType
     */
    public function setOffer_Data(\StructType\Offer_DataType $offer_Data = null)
    {
        $this->Offer_Data = $offer_Data;
        return $this;
    }
    /**
     * Get version value
     * @return string|null
     */
    public function getVersion()
    {
        return $this->version;
    }
    /**
     * Set version value
     * @param string $version
     * @return \StructType\Offer_RequestType
     */
    public function setVersion($version = null)
    {
        // validation for constraint: string
        if (!is_null($version) && !is_string($version)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($version, true), gettype($version)), __LINE__);
        }
        $this->version = $version;
        return $this;
    }
}
